Index: /palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_module.f90	(revision 4140)
+++ /palm/trunk/SOURCE/data_output_module.f90	(revision 4141)
@@ -38,10 +38,24 @@
 !> Data-output module to handle output of variables into output files.
 !>
-!> The module first creates an interal database containing all meta data of all
-!> output quantities. Output files are then inititialized and prepared for
-!> storing data, which are finally written to file.
+!> The module first creates an interal database containing all meta data of all output quantities.
+!> After defining all meta data, the output files are initialized and prepared for writing. When
+!> writing is finished, files can be finalized and closed.
+!> The order of calls are as follows:
+!>   1. Initialize the module via
+!>      'dom_init'
+!>   2. Define output files via (multiple calls of)
+!>      'dom_def_file', 'dom_def_att', 'dom_def_dim', 'dom_def_var'
+!>   3. Leave definition stage via
+!>      'dom_def_end'
+!>   4. Write output data into file via
+!>      'dom_write_var'
+!>   5. Finalize the output via
+!>      'dom_finalize_output'
+!> If any routine exits with a non-zero return value, the error message of the last encountered
+!> error can be fetched via 'dom_get_error_message'.
+!> For debugging purposes, the content of the database can be written to the debug output via
+!> 'dom_database_debug_output'.
 !>
 !> @todo Convert variable if type of given values do not fit specified type.
-!> @todo Remove iwp from index (and similar) variables.
 !--------------------------------------------------------------------------------------------------!
 MODULE data_output_module
@@ -52,5 +66,5 @@
       ONLY: netcdf4_init_dimension, &
             netcdf4_get_error_message, &
-            netcdf4_init_end, &
+            netcdf4_stop_file_header_definition, &
             netcdf4_init_module, &
             netcdf4_init_variable, &
@@ -64,5 +78,5 @@
             binary_get_error_message, &
             binary_init_dimension, &
-            binary_init_end, &
+            binary_stop_file_header_definition, &
             binary_init_module, &
             binary_init_variable, &
@@ -73,5 +87,6 @@
    IMPLICIT NONE
 
-   INTEGER(iwp), PARAMETER ::  charlen = 100_iwp  !< maximum length of character variables
+   INTEGER, PARAMETER ::  charlen = 100  !< maximum length of character variables
+   INTEGER, PARAMETER ::  no_id = -1     !< default ID if no ID was assigned
 
    TYPE attribute_type
@@ -87,23 +102,23 @@
 
    TYPE variable_type
-      CHARACTER(LEN=charlen) ::  data_type = ''       !< data type
-      CHARACTER(LEN=charlen) ::  name                 !< variable name
-      INTEGER(iwp)           ::  id = -1              !< id within file
-      LOGICAL                ::  is_global = .FALSE.  !< true if global variable
-      CHARACTER(LEN=charlen), DIMENSION(:), ALLOCATABLE ::  dimension_names  !< list of dimension names
-      INTEGER(iwp),           DIMENSION(:), ALLOCATABLE ::  dimension_ids    !< list of dimension ids
-      TYPE(attribute_type),   DIMENSION(:), ALLOCATABLE ::  attributes       !< list of attributes
+      CHARACTER(LEN=charlen)                            ::  data_type = ''       !< data type
+      CHARACTER(LEN=charlen)                            ::  name                 !< variable name
+      INTEGER                                           ::  id = no_id           !< id within file
+      LOGICAL                                           ::  is_global = .FALSE.  !< true if global variable
+      CHARACTER(LEN=charlen), DIMENSION(:), ALLOCATABLE ::  dimension_names      !< list of dimension names used by variable
+      INTEGER,                DIMENSION(:), ALLOCATABLE ::  dimension_ids        !< list of dimension ids used by variable
+      TYPE(attribute_type),   DIMENSION(:), ALLOCATABLE ::  attributes           !< list of attributes
    END TYPE variable_type
 
    TYPE dimension_type
-      CHARACTER(LEN=charlen) ::  data_type = ''       !< data type
-      CHARACTER(LEN=charlen) ::  name                 !< dimension name
-      INTEGER(iwp)           ::  id = -1              !< dimension id within file
-      INTEGER(iwp)           ::  length               !< length of dimension
-      INTEGER(iwp)           ::  length_mask          !< length of masked dimension
-      INTEGER(iwp)           ::  var_id = -1          !< associated variable id within file
-      LOGICAL                ::  is_masked = .FALSE.  !< true if masked
-      INTEGER(iwp),    DIMENSION(2)              ::  bounds                !< lower and upper bound of dimension
-      INTEGER(iwp),    DIMENSION(:), ALLOCATABLE ::  masked_indices        !< list of masked indices of dimension
+      CHARACTER(LEN=charlen)                     ::  data_type = ''        !< data type
+      CHARACTER(LEN=charlen)                     ::  name                  !< dimension name
+      INTEGER                                    ::  id = no_id            !< dimension id within file
+      INTEGER                                    ::  length                !< length of dimension
+      INTEGER                                    ::  length_mask           !< length of masked dimension
+      INTEGER                                    ::  variable_id = no_id   !< associated variable id within file
+      LOGICAL                                    ::  is_masked = .FALSE.   !< true if masked
+      INTEGER,         DIMENSION(2)              ::  bounds                !< lower and upper bound of dimension
+      INTEGER,         DIMENSION(:), ALLOCATABLE ::  masked_indices        !< list of masked indices of dimension
       INTEGER(KIND=1), DIMENSION(:), ALLOCATABLE ::  masked_values_int8    !< masked dimension values if 16bit integer
       INTEGER(KIND=2), DIMENSION(:), ALLOCATABLE ::  masked_values_int16   !< masked dimension values if 16bit integer
@@ -125,26 +140,22 @@
 
    TYPE file_type
-      CHARACTER(LEN=charlen) ::  format = ''        !< file format
-      CHARACTER(LEN=charlen) ::  name = ''          !< file name
-      INTEGER(iwp)           ::  id = -1            !< id of file
-      LOGICAL                ::  is_init = .FALSE.  !< true if initialized
-      TYPE(attribute_type), DIMENSION(:), ALLOCATABLE ::  attributes  !< list of attributes
-      TYPE(dimension_type), DIMENSION(:), ALLOCATABLE ::  dimensions  !< list of dimensions
-      TYPE(variable_type),  DIMENSION(:), ALLOCATABLE ::  variables   !< list of variables
+      CHARACTER(LEN=charlen)                          ::  format = ''        !< file format
+      CHARACTER(LEN=charlen)                          ::  name = ''          !< file name
+      INTEGER                                         ::  id = no_id         !< id of file
+      LOGICAL                                         ::  is_init = .FALSE.  !< true if initialized
+      TYPE(attribute_type), DIMENSION(:), ALLOCATABLE ::  attributes         !< list of attributes
+      TYPE(dimension_type), DIMENSION(:), ALLOCATABLE ::  dimensions         !< list of dimensions
+      TYPE(variable_type),  DIMENSION(:), ALLOCATABLE ::  variables          !< list of variables
    END TYPE file_type
 
 
-   CHARACTER(LEN=charlen) ::  output_file_format = 'binary'  !< file format (namelist parameter)
-   CHARACTER(LEN=charlen) ::  output_file_suffix = ''        !< file suffix added to each file name
-
-   CHARACTER(LEN=800) ::  internal_error_message = '' !< string containing the last error message
-   CHARACTER(LEN=800) ::  temp_string                 !< dummy string
-
-   INTEGER(iwp) ::  debug_output_unit  !< Fortran Unit Number of the debug-output file
-   INTEGER      ::  nf = 0             !< number of files
-   INTEGER      ::  master_rank = 0    !< master rank for tasks to be executed by single PE only
-   INTEGER      ::  output_group_comm  !< MPI communicator addressing all MPI ranks which participate in output
-
-   INTEGER(iwp), PARAMETER ::  no_var_id = -1  !< value of var_id if no variable is selected
+   CHARACTER(LEN=charlen) ::  output_file_suffix = ''      !< file suffix added to each file name
+   CHARACTER(LEN=800)     ::  internal_error_message = ''  !< string containing the last error message
+   CHARACTER(LEN=800)     ::  temp_string                  !< dummy string
+
+   INTEGER ::  debug_output_unit  !< Fortran Unit Number of the debug-output file
+   INTEGER ::  nfiles = 0         !< number of files
+   INTEGER ::  master_rank = 0    !< master rank for tasks to be executed by single PE only
+   INTEGER ::  output_group_comm  !< MPI communicator addressing all MPI ranks which participate in output
 
    LOGICAL ::  print_debug_output = .FALSE.  !< if true, debug output is printed
@@ -187,7 +198,7 @@
 
    !> Prepare for output: evaluate database and create files
-   INTERFACE dom_start_output
-      MODULE PROCEDURE dom_start_output
-   END INTERFACE dom_start_output
+   INTERFACE dom_def_end
+      MODULE PROCEDURE dom_def_end
+   END INTERFACE dom_def_end
 
    !> Write variables to file
@@ -206,15 +217,20 @@
    END INTERFACE dom_get_error_message
 
+   !> Write database to debug output
+   INTERFACE dom_database_debug_output
+      MODULE PROCEDURE dom_database_debug_output
+   END INTERFACE dom_database_debug_output
+
    PUBLIC &
-      dom_database_debug_output, &
+      dom_init, &
+      dom_def_file, &
+      dom_def_dim, &
+      dom_def_var, &
       dom_def_att, &
-      dom_def_dim, &
-      dom_def_file, &
-      dom_def_var, &
+      dom_def_end, &
+      dom_write_var, &
       dom_finalize_output, &
       dom_get_error_message, &
-      dom_init, &
-      dom_start_output, &
-      dom_write_var
+      dom_database_debug_output
 
 CONTAINS
@@ -224,5 +240,10 @@
 ! Description:
 ! ------------
-!> Initialize data-output module
+!> Initialize data-output module.
+!> Provide some general information of the main program.
+!> The optional argument 'file_suffix_of_output_group' defines a file suffix which is added to all
+!> output files. If multiple output groups (groups of MPI ranks, defined by
+!> 'mpi_comm_of_output_group') exist, a unique file suffix must be given for each group. This
+!> prevents that multiple groups try to open and write to the same output file.
 !--------------------------------------------------------------------------------------------------!
 SUBROUTINE dom_init( file_suffix_of_output_group, mpi_comm_of_output_group, master_output_rank, &
@@ -238,5 +259,5 @@
    INTEGER, INTENT(IN)           ::  program_debug_output_unit  !< file unit number for debug output
 
-   LOGICAL, INTENT(IN) ::  debug_output  !< if true, debug output is printed
+   LOGICAL, INTENT(IN)           ::  debug_output               !< if true, debug output is printed
 
 
